﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Babel.ParserGenerator;

namespace dragonangel.phpProject.Language.DSL
{
    public class CodeInterface : CodeExpression
    {
        public CodeInterface(string className, LexLocation begin, LexLocation end)
            : base(begin, end)
        {
            this.name = className;
        }

        protected string name;
        public string Name
        {
            get { return name; }
            set { name = value; }
        }


        protected IList<CodeFunction> members = new List<CodeFunction>();
        public IList<CodeFunction> Members
        {
            get { return members; }
            set { members = value; }
        }


        protected List<string> interfaces = new List<string>();
        public List<string> Interfaces
        {
            get { return interfaces; }
            set { interfaces = value; }
        }

        public string Iface
        {
            get { return string.Join(",", interfaces.ToArray()); }
            set
            {
                foreach (string item in value.Split(','))
                {
                    interfaces.Add(item.Trim());
                }
            }
        }

        public override CodeExpression GetExpression(int line, int col)
        {
            foreach (CodeMember exp in members)
            {
                CodeExpression result = exp.GetExpression(line, col);
                if (result != null)
                    return result;
            }
            return base.GetExpression(line, col);
        }

        public override CodeExpression GetFirstParentContainingMember(int line, int col)
        {
            foreach (CodeMember exp in members)
            {
                CodeExpression result = exp.GetFirstParentContainingMember(line, col);
                if (result != null)
                    return result;
            }
            return base.GetFirstParentContainingMember(line, col);
        }
    }
}
